(declare-fun x () (_ BitVec 32))
(declare-fun y () (_ BitVec 32))
(declare-fun z () (_ BitVec 32))

(declare-fun EAX () (_ BitVec 32))
(declare-fun EAX2 () (_ BitVec 32))
(declare-fun EDX () (_ BitVec 32))
(declare-fun EDX2 () (_ BitVec 32))
(declare-fun CF () (_ BitVec 1))
(declare-fun ZF () Bool)

; X86 ASM

; movl    8(%esp), %eax
; mull    12(%esp)
(assert (let ((mul (bvmul ((_ zero_extend 32) x) ((_ zero_extend 32) y))))
  (and
    (= EAX ((_ extract 31 0) mul))
    (= EDX ((_ extract 63 32) mul))
  )))

; addl    16(%esp), %eax
(assert (and
  (= EAX2 (bvadd EAX z))
  (= CF ((_ extract 32 32) (bvadd ((_ zero_extend 1) EAX) ((_ zero_extend 1) z))))
))

; adcl    %edx, %edx
(assert (and
  (= EDX2 (bvadd EDX EDX ((_ zero_extend 31) CF)))
  (= ZF (= EDX2 #x00000000))
))


(assert (not (=
  (ite ZF EAX2 #x00000000)

  ; LLVM
  (let ((overflow
    (or (bvugt (bvmul ((_ zero_extend 32) x) ((_ zero_extend 32) y)) #x00000000FFFFFFFF)
        (bvugt (bvadd ((_ zero_extend 4) (bvmul x y)) ((_ zero_extend 4) z)) #x0FFFFFFFF))))
    (ite overflow #x00000000 (bvadd (bvmul x y) z)))
)))

(check-sat)
(get-model)
